Bug 1646373 - glibc: Crash in getaddrinfo_a when thread creation fails
Summary: glibc: Crash in getaddrinfo_a when thread creation fails
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: glibc
Version: 7.7
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: ---
Assignee: DJ Delorie
QA Contact: qe-baseos-tools
URL:
Whiteboard:
Depends On: 1646379 1646381
Blocks: 1660844
TreeView+ depends on / blocked
 
Reported: 2018-11-05 13:29 UTC by Florian Weimer
Modified: 2019-08-06 12:49 UTC (History)
7 users (show)

Fixed In Version: glibc-2.17-269.el7
Doc Type: No Doc Update
Doc Text:
Clone Of:
: 1646379 1646381 (view as bug list)
Environment:
Last Closed: 2019-08-06 12:49:05 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2019:2118 None None None 2019-08-06 12:49:33 UTC
Sourceware 22927 None None None 2019-07-01 14:53:33 UTC

Description Florian Weimer 2018-11-05 13:29:25 UTC
From the upstream bug report:

At line 237 in gai_misc.c:

lastp = requests_tail;
if (requests_tail == NULL)
  requests = requests_tail = newp;
else ...

If requests_tail was NULL then lastp remains NULL. 
Unfortunately if gai_create_helper_thread fails, lastp is de-referenced at line 267 which will cause a SIGSEGV.

Comment 1 Florian Weimer 2018-11-05 13:30:00 UTC
This should be reproducible with a custom malloc which fails after the right number of allocations.

Comment 3 Florian Weimer 2018-11-05 13:54:12 UTC
Upstream commit:

commit bd3b0fbae33a9a4cc5e2daf049443d5cf03d4251
Author: Andreas Schwab <schwab@suse.de>
Date:   Mon Nov 5 12:47:30 2018 +0100

    libanl: properly cleanup if first helper thread creation failed (bug 22927)

Comment 6 Sergey Kolosov 2019-06-27 09:45:08 UTC
Verified with modified __gai_create_helper_thread() function which always returns -1 and a test that calls getaddrinfo_a(). In glibc-2.17-269.el7 getaddrinfo_a() doesn't crash but returns EAGAIN.

Comment 9 errata-xmlrpc 2019-08-06 12:49:05 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2019:2118


Note You need to log in before you can comment on or make changes to this bug.